# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.bandwidth_part import BandwidthPart  # noqa: F401,E501
from swagger_server import util


class ComponentCarrier(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, cc_bandwidth: int=None, cc_central_frequency: int=None, cc_bwp_list: List[BandwidthPart]=None):  # noqa: E501
        """ComponentCarrier - a model defined in Swagger

        :param cc_bandwidth: The cc_bandwidth of this ComponentCarrier.  # noqa: E501
        :type cc_bandwidth: int
        :param cc_central_frequency: The cc_central_frequency of this ComponentCarrier.  # noqa: E501
        :type cc_central_frequency: int
        :param cc_bwp_list: The cc_bwp_list of this ComponentCarrier.  # noqa: E501
        :type cc_bwp_list: List[BandwidthPart]
        """
        self.swagger_types = {
            'cc_bandwidth': int,
            'cc_central_frequency': int,
            'cc_bwp_list': List[BandwidthPart]
        }

        self.attribute_map = {
            'cc_bandwidth': 'cc-bandwidth',
            'cc_central_frequency': 'cc-central-frequency',
            'cc_bwp_list': 'cc-bwp-list'
        }
        self._cc_bandwidth = cc_bandwidth
        self._cc_central_frequency = cc_central_frequency
        self._cc_bwp_list = cc_bwp_list

    @classmethod
    def from_dict(cls, dikt) -> 'ComponentCarrier':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The component-carrier of this ComponentCarrier.  # noqa: E501
        :rtype: ComponentCarrier
        """
        return util.deserialize_model(dikt, cls)

    @property
    def cc_bandwidth(self) -> int:
        """Gets the cc_bandwidth of this ComponentCarrier.


        :return: The cc_bandwidth of this ComponentCarrier.
        :rtype: int
        """
        return self._cc_bandwidth

    @cc_bandwidth.setter
    def cc_bandwidth(self, cc_bandwidth: int):
        """Sets the cc_bandwidth of this ComponentCarrier.


        :param cc_bandwidth: The cc_bandwidth of this ComponentCarrier.
        :type cc_bandwidth: int
        """

        self._cc_bandwidth = cc_bandwidth

    @property
    def cc_central_frequency(self) -> int:
        """Gets the cc_central_frequency of this ComponentCarrier.


        :return: The cc_central_frequency of this ComponentCarrier.
        :rtype: int
        """
        return self._cc_central_frequency

    @cc_central_frequency.setter
    def cc_central_frequency(self, cc_central_frequency: int):
        """Sets the cc_central_frequency of this ComponentCarrier.


        :param cc_central_frequency: The cc_central_frequency of this ComponentCarrier.
        :type cc_central_frequency: int
        """

        self._cc_central_frequency = cc_central_frequency

    @property
    def cc_bwp_list(self) -> List[BandwidthPart]:
        """Gets the cc_bwp_list of this ComponentCarrier.


        :return: The cc_bwp_list of this ComponentCarrier.
        :rtype: List[BandwidthPart]
        """
        return self._cc_bwp_list

    @cc_bwp_list.setter
    def cc_bwp_list(self, cc_bwp_list: List[BandwidthPart]):
        """Sets the cc_bwp_list of this ComponentCarrier.


        :param cc_bwp_list: The cc_bwp_list of this ComponentCarrier.
        :type cc_bwp_list: List[BandwidthPart]
        """

        self._cc_bwp_list = cc_bwp_list
